;************************************************
;   Full-screen memory editor for FX-870P/VX-3
;     (C)2007 Miyura (miyura321@ybb.ne.jp)
;************************************************

FX870P:	EQU	1	;FX-870P
VX3:	EQU	2	;VX-3
AI1000:	EQU	3	;AI-1000

MODEL:	EQU	AI1000

#if MODEL=FX870P
TCAPS:	EQU	&H00B6
CROFF:	EQU	&H032E
KYIN:	EQU	&H03A4
BIOS:	EQU	&H5321

LCDST:	EQU	&H1100
EDCSR:	EQU	&H1101
BOARE:	EQU	&H1107
KYSTA:	EQU	&H1114
EDTOP:	EQU	&H113B
CHRDT:	EQU	&H0000
#endif
#if MODEL=VX3
TCAPS:	EQU	&H013E
CROFF:	EQU	&H1FAE
KYIN:	EQU	&H03D1
BIOS:	EQU	&H5CA7

LCDST:	EQU	&H6100
EDCSR:	EQU	&H6101
BOARE:	EQU	&H6107
KYSTA:	EQU	&H621B
EDTOP:	EQU	&H6242
CHRDT:	EQU	&H0000
#endif
#if MODEL=AI1000
TCAPS:	EQU	&H01EC	;-->啶ϊ
CROFF:	EQU	&H29E8	;J[\ON(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H0460	;WL[̓[`($0=L[R[h)
BIOS:	EQU	&H9881	;BIOS(BANK0)R[BANK1ɖ߂(FX-870P &H5321)

LCDST:	EQU	&H08CA	;LCDXe[^X
EDCSR:	EQU	&H08CB	;J[\ʒu
BOARE:	EQU	&H08D1	;J[\ړ͈̓{g
KYSTA:	EQU	&H09E5	;L[͏
CHRDT:	EQU	&H0DBB	;tHgi[Ԓn(BANK0)
EDTOP:	EQU	&H0100	;EDTOPobt@
#endif

	ORG	EDTOP + 104
	START	START
;
;	reset resistors
;
START:	LDW	$14,8
	LDW	$16,32
	XRM	$17,$17,8
;
;	set LCDST
;
	LDW	$0,LCDST
	ST	&H0F,($0)
;
;	set cursor bottom
;
	LDW	$0,BOARE
	ST	&H7F,($0)
;
;	clear EDTOP
;
	PRE	IX,EDTOP
	LD	$0,$31
STA01:  LD	$1,$0
	AN	$1,&H1F
	SBC	$1,&H1D
	JR	NZ,STA02
	LD	$2,":",STA03
STA02:	LD	$2," "
STA03:	ST	$2,(IX+$0)
	AD	$0,$30
	SBC	$0,&H80
	JR	NZ,STA01

	CAL	DUMP

RETUN:	LDW	$0,RETUN-1
	PHSW	$1
;
;	set cursor
;
CSR:	LD	$0,$18
	LD	$1,$0

	SBC	$22,$31
	JR	NZ,CSR01

	AN	$0,&H03
	AN	$1,&H0C
	DIU	$1
	BID	$1
	OR	$1,$0
	AD	$1,$30,CSR02

CSR01:	AN	$0,&H07
	AN	$1,&H18
	BIU	$1
	BIU	$1
	LD	$2,$0
	BIU	$2
	AD	$2,$0
	OR	$1,$2
	AD	$1,6
	AD	$1,$23
CSR02:	PRE	IX,EDCSR
	ST	$1,(IX+$31)
KEY:	CAL	@KYIN
	CAL	CNHEX
	JR	C,WRITE
;
;	load jump address
;
	PRE	IX,JPTBL
	LD	$5,11
KEY01:	LDIM	$1,(IX+$31),3
	SBC	$1,$0
	JR	Z,KEY02
	SB	$5,$30
	JR	NZ,KEY01
	JR	KEY
KEY02:	JP	$2
;
;	input 0-9,A-F
;
WRITE:	SBC	$22,$31
	JR	NZ,WRT03
;
;	input address
;
	LD	$1,$31
	LDW	$2,&H000F
	LD	$4,$18
	AN	$4,&H03
WRT01:	SBC	$4,3
	JR	Z,WRT02
	DIUM	$0,4
	AD	$4,$30,WRT01
WRT02:	LDW	$4,$18
	AN	$4,&H0C
	BIU	$4
	INVW	$2
	ADW	$20,$4
	ANW	$20,$2
	ORW	$20,$0
	SBW	$20,$4
	SBC	$18,15
	JR	Z,RIG01
	AD	$18,$30
	JP	DUMP
;
;	write data
;
WRT03:	CAL	SETBK
	PRE	IX,$20
	LDD	$1,(IX+$18)
	SBC	$23,$31
	JR	NZ,WRT04
	DIU	$0
	AN	$1,&H0F,WRT05
WRT04:	AN	$1,&HF0
WRT05:	OR	$1,$0
	ST	$1,(IX+$31)
	PST	UA,&H55
	LD	$0,$18
	AD	$0,$23
	SBC	$0,32
	CAL	NZ,DUMP1
	JR	RIG02
;
;	move cursor to right
;
RIGHT:	SBC	$22,$31
	JR	NZ,RIG02
	AD	$18,$30
	SBC	$18,16
	RTN	C
RIG01:	LD	$18,&H0C,ROLUP
RIG02:	XR	$23,$30
	RTN	NZ
RIG03:	AD	$18,$30
	SBC	$18,32
	RTN	C
RIG04:	LD	$18,&H18,ROLUP
;
;	move cursor to left
;
LEFT:	SBC	$22,$31
	JR	NZ,LFT01
	LD	$0,3,LFT02
LFT01:	XR	$23,$30
	RTN	Z
	LD	$0,7
LFT02:	SB	$18,$30
	RTN	NC
	LD	$18,$0,ROLDN
;
;	up cursor
;
UP:	SBC	$22,$31
	JR	NZ,UP01
	LD	$0,4,UP02
UP01:	LD	$0,8
UP02:	SB	$18,$0
	RTN	NC
	AD	$18,$0
ROLDN:	SBW	$20,$14,DUMP
;
;	down cursor
;
DOWN:	SBC	$22,$31
	JR	NZ,DWN01
	SBC	$18,12
	JR	NC,ROLUP
	AD	$18,4
	RTN
DWN01:	SBC	$18,24
	JR	NC,ROLUP
	AD	$18,8
	RTN
ROLUP:	ADW	$20,$14,DUMP
;
;	screen up
;
SCNUP:	ADW	$20,$16,DUMP
;
;	screen down
;
SCNDN:	SBW	$20,$16,DUMP
;
;	change bank
;
BANKC:	AD	$24,$30
	AN	$24,&H03
;
;	32byte dump
;
DUMP:	PRE	IX,$20
	PRE	IZ,EDTOP
	LD	$10,4

DMP01:	LD	$0,$24
	CAL	CNASC
	STI	$1,(IZ+$31)

	GRE	IX,$3
	LD	$0,$4
	CAL	CNASC
	STIW	$0,(IZ+$31)
	LD	$0,$3
	CAL	CNASC
	STIW	$0,(IZ+$31)

	LDW	$6,&H0800
	CAL	SETBK
DMP02:	LDI	$0,(IX+$31)
	AD	$6,$0
	CAL	CNASC
	STIW	$0,(IZ+$30)
	SB	$7,$30
	JR	NZ,DMP02
	PST	UA,&H55

	LD	$0,$6
	CAL	CNASC
	STIW	$0,(IZ+$30)
	SB	$10,$30
	JR	NZ,DMP01

	PRE	IX,EDTOP
	PRE	IZ,CHRDT
#if MODEL=AI1000
	PST	UA,&H15
#else
	PST	UA,&H95
#endif
	LD	$8,$31
	CAL	DISPL
	LD	$8,&H10
	CAL	DISPL
	PST	UA,&H55
	RTN
;
;	move cursor to home position
;
HOME:	LD	$18,$31,EXC00
;
;	move cursor to line top
;
LNTOP:	SBC	$22,$31
	JR	NZ,LNT01
	AN	$18,&H0C
	RTN
LNT01:	AN	$18,&H18,EXC00
;
;	move cursor to line end
;
LNEND:	SBC	$22,$31
	JR	NZ,LNE01
	OR	$18,3
	RTN
LNE01:	OR	$18,7
	LD	$23,$30
	RTN
;
;	exchange cursor position
;
EXCSR:	XR	$22,$30
	JR	NZ,EXC01
	AN	$18,&H18
	BID	$18
EXC00:	LD	$23,$31
	RTN
EXC01:	AN	$18,&H0C
	BIU	$18
	RTN
;
;	1 byte dump
;
DUMP1:	PRE	IX,EDCSR
	SB	(IX+$31),$23

	CAL	SETBK
	PRE	IX,$20
	LD	$0,(IX+$18)
	PST	UA,&H55
	CAL	OUTAC

	PRE	IX,EDCSR
	LD	$0,(IX+$31)
	AN	$0,&HE0
	OR	$0,&H1E
	ST	$0,(IX+$31)

	CAL	SETBK
	PRE	IX,$20
	LD	$0,$18
	AN	$0,&H18
	LD	$1,7
	LDI	$0,(IX+$0)
DMP1L:	LDI	$2,(IX+$31)
	AD	$0,$2
	SB	$1,$30
	JR	NZ,DMP1L
	PST	UA,&H55

OUTAC:	CAL	CNASC
	PRE	IX,EDCSR
	LD	$6,(IX+$31)
	PRE	IX,EDTOP
	STW	$0,(IX+$6)

	PRE	IZ,CHRDT
#if MODEL=AI1000
	PST	UA,&H15
#else
	PST	UA,&H95
#endif
	LD	$8,&H82

	LD	$9,$6
	CAL	OUTCH
	LD	$6,$9

	AD	$6,$30
	LD	$0,$1
	CAL	OUTCH

	PST	UA,&H55
	RTN
;
;	output character
;
OUTCH:	CAL	LCDXY
	SB	$0,&H20
	LD	$2,$0
	BIU	$2
	AD	$2,$0
	BIU	$2
	LDM	$2,(IZ+$2),6
	STLM	$2,6
	RTN
;
;	DOTDS routine
;
DISPL:	PPO	&HC5
	LD	$0,&H82
	OR	$0,$8
	XRW	$1,$1
	STLM	$0,3
	LD	$7,$31
	PPO     &HC4
DIS01:	LD	$6,$31
DIS02:	LD	$0,$6
	OR	$0,$7
	OR	$0,$8
	LD	$0,(IX+$0)
	SB	$0,&H20
	BIU	$0
	LD	$1,$0
	BIU	$0
	AD	$1,$0
	LDM	$0,(IZ+$1),6
	STLM	$0,6
	AD	$6,$30
	JR	LNZ,DIS02
	AD	$7,&H20
	ANC	$7,&H80
	JR	Z,DIS01
	RTN
;
;	convert binary to ascii
;
CNASC:	LD	$1,$0
	DID	$0
	AD	$0,"0"
	SBC	$0,&H3A
	JR	C,CNA01
	AD	$0,7
CNA01:	AN	$1,&H0F
	AD	$1,"0"
	SBC	$1,&H3A
	RTN	C
	AD	$1,7
	RTN
;
;	convert ascii to hex
;
CNHEX:	LDW	$28,TCAPS
	CAL	RCS
	SBC	$0,"A"
	JR	C,CNH01
	SBC	$0,&H47,CHN03
CNH01:	SBC	$0,"0"
	JR	C,CHN02
	SBC	$0,&H3A,CHN03
CHN02:	ADC	$30,$31
CHN03:	RTN	NC
	SB	$0,"0"
	SBC	$0,10
	RTN	C
	AD	$0,&HF9
	RTN
;
;	set bank
;
SETBK:	LD	$2,$24
	DIU	$2
	GST	UA,$4
	AN	$4,&HCF
	OR	$4,$2
	PST	UA,$4
	RTN
;
;	input key
;
@KYIN:	CAL	CSRST
	LDW	$28,CROFF
	CAL	RCS

	LDW	$0,KYSTA
#if MODEL=AI1000
	LD	$28,($0)	;
	OR	$28,4		;(Bit2=ON)
	ST	$28,($0)	;
#else
	ST	&H06,($0)
#endif
	LDW	$28,KYIN
	CAL	RCS
;
;	cursor set/reset
;
CSRST:	PRE	IX,EDCSR
	LD	$6,(IX+$31)
	LD	$8,&H22
	CAL	LCDXY
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	RTN
;
;	calulation LCD X-Y address
;
LCDXY:	LD	$2,$6
	AN	$2,&H10
	OR	$2,$8

	LD	$3,$6
	AN	$3,7
	LD	$4,$3
	BIU	$4
	AD	$3,$4
	BIU	$3
	BIU	$3

	LD	$4,$6
	AN	$4,&H08
	DIU	$4
	OR	$3,$4

	LD	$4,$6
	DID	$4
	BID	$4

	PPO	&HC5
	STLM	$2,3
	PPO	&HC4
	RTN
;
;	BIOS call
;
RCS:	PST	UA,&H54
	JP	BIOS

;
;	jump address and key data table
;
JPTBL:	DB	&H1C		; ""
	DW	RIGHT

	DB	&H1D		; ""
	DW	LEFT

	DB	&H1E		; ""  
	DW	UP

	DB	&H1F		; ""
	DW	DOWN

	DB	&H02		; LINE TOP
	DW	LNTOP

	DB	&H06		; LINE END
	DW	LNEND

	DB	&H0B		; HOME
	DW	HOME

	DB	"+"		; SCREEN UP
	DW	SCNUP

	DB	"-"		; SCREEN DOWN
	DW	SCNDN

	DB	"*"		; "*"
	DW	EXCSR

	DB	"/"		; "/"
	DW	BANKC
