;*************************************************
;  Full-screen memory editor for PB-1000/C Rev.2
;     (C)2007 Miyura (miyura321@ybb.ne.jp)
;*************************************************

PB1000:	EQU	1
PB1000C:EQU	2
MODEL:	EQU	PB1000

CHEX1:	EQU	&H0160
CLRME:	EQU	&H016E

#if MODEL=PB1000
CROFF:	EQU	&H913F
KYIN: 	EQU	&HE8B9
#else
CROFF:	EQU	&H91F0
KYIN: 	EQU	&HEAAD
#endif

EDTOP:	EQU	&H6100
LCDST:	EQU	&H68C7
EDCSR:	EQU	&H68C8
BOARE:	EQU	&H68CE
KYSTA:	EQU	&H68D2
ACJMP:	EQU	&H694D
CHRDT:	EQU	&H8000


	ORG	EDTOP + 90
	START	START
;
;	reset resistors
;
START:	LDW	$13,8
	LDW	$15,32
	XRM	$17,$17,8
	XRM	$25,$25,5
;
;	set LCDST
;
	LDW	$0,LCDST
	ST	&H0F,($0)
;
;	set cursor bottom
;
	LDW	$0,BOARE
	ST	&H7F,($0)
;
;	set ACJMP
;
	LDW	$0,KEY
	PRE	IZ,ACJMP
	STW	$0,(IZ+$31)
;
;	clear EDTOP
;
	PRE	IX,EDTOP
	LD	$0,$31
STA01:  LD	$1,$0
	AN	$1,&H1F
	SBC	$1,&H1D
	JR	NZ,STA02
	LD	$2,":",STA03
STA02:	LD	$2," "
STA03:	ST	$2,(IX+$0)
	AD	$0,$30
	SBC	$0,&H80
	JR	NZ,STA01

	CAL	BNK01

RETUN:	LDW	$0,RETUN-1
	PHSW	$1
;
;	set cursor
;
CSR:	LD	$0,$18
	LD	$1,$0
	SBC	$28,$31
	JR	NZ,CSR01
	AN	$0,&H03
	AN	$1,&H0C
	DIU	$1
	BID	$1
	OR	$1,$0
	AD	$1,$30,CSR02
CSR01:	AN	$0,&H07
	AN	$1,&H18
	BIU	$1
	BIU	$1
	LD	$2,$0
	BIU	$2
	AD	$2,$0
	OR	$1,$2
	AD	$1,6
	AD	$1,$29
CSR02:	PRE	IX,EDCSR
	ST	$1,(IX+$31)
KEY:	CAL	@KYIN
;
;	convert hexkeys to A-F
;
	PRE	IX,HEXKY
	LD	$1,"A"
KEY01:	LDI	$2,(IX+$31)
	SBC	$2,$0
	JR	Z,KEY02
	SBC	$1,"F"
	JR	Z,KEY03
	AD	$1,$30,KEY01
KEY02:	LD	$0,$1
KEY03:	CAL	CHEX1
	JR	C,WRITE
;
;	load jump address
;
	PRE	IX,JPTBL
	LD	$5,23
KEY04:	LDIM	$1,(IX+$31),3
	SBC	$1,$0
	JR	Z,KEY05
	SB	$5,$30
	JR	NZ,KEY04
	JR	KEY
KEY05:	JP	$2

WRITE:	SBC	$28,$31
	JR	NZ,WRT03
;
;	input address
;
	LD	$1,$31
	LDW	$2,&H000F
	LD	$4,$18
	AN	$4,&H03
WRT01:	SBC	$4,3
	JR	Z,WRT02
	DIUM	$0,4
	AD	$4,$30,WRT01
WRT02:	LDW	$4,$18
	AN	$4,&H0C
	BIU	$4
	INVW	$2
	ADW	$20,$4
	ANW	$20,$2
	ORW	$20,$0
	SBW	$20,$4
	SBC	$18,15
	JR	Z,RIG01
	AD	$18,$30
	JP	DUMP
;
;	write data
;
WRT03:	PRE	IX,$20
	LDD	$1,(IX+$18)
	SBC	$29,$31
	JR	NZ,WRT04
	DIU	$0
	AN	$1,&H0F,WRT05
WRT04:	AN	$1,&HF0
WRT05:	OR	$1,$0
	PST	IB,$31
	ST	$1,(IX+$31)
	PST	IB,&HA0
	LD	$0,$18
	AD	$0,$29
	SBC	$0,32
	CAL	NZ,DUMP1
	JR	RIG02
;
;	move cursor to right
;
RIGHT:	SBC	$28,$31
	JR	NZ,RIG02
	AD	$18,$30
	SBC	$18,16
	RTN	C
RIG01:	LD	$18,&H0C,ROLUP
RIG02:	XR	$29,$30
	RTN	NZ
RIG03:	AD	$18,$30
	SBC	$18,32
	RTN	C
RIG04:	LD	$18,&H18,ROLUP
;
;	move cursor to left
;
LEFT:	SBC	$28,$31
	JR	NZ,LFT01
	LD	$0,3,LFT02
LFT01:	XR	$29,$30
	RTN	Z
	LD	$0,7
LFT02:	SB	$18,$30
	RTN	NC
	LD	$18,$0,ROLDN
;
;	up cursor
;
UP:	SBC	$28,$31
	JR	NZ,UP01
	LD	$0,4,UP02
UP01:	LD	$0,8
UP02:	SB	$18,$0
	RTN	NC
	AD	$18,$0,ROLDN
;
;	down cursor
;
DOWN:	SBC	$28,$31
	JR	NZ,DWN01
	SBC	$18,12
	JR	NC,ROLUP
	AD	$18,4
	RTN
DWN01:	SBC	$18,24
	JR	NC,ROLUP
	AD	$18,8
	RTN
;
;	reset address
;
ADRRE:	LD	$0,$20
	AN	$20,&HF8
	SBC	$28,$31
	JR	Z,DUMP
	SB	$0,$20
	AD	$18,$0
	SBC	$18,&H20
	JR	C,DUMP
	SB	$18,8,ROLUP
;
;	reset cursor position
;
CURRE:	SBC	$28,$31
	RTN	Z
	LDW	$0,$18
	AN	$0,&H07
	AN	$18,&H18
	ADW	$20,$0,DUMP
;
;	screen roll up/down
;
ROLUP:	ADW	$20,$13,DUMP
ROLDN:	SBW	$20,$13,DUMP
SCLUP:	ADW	$20,$15,DUMP
SCLDN:	SBW	$20,$15,DUMP
;
;	change bank
;
BANKC:	AD	$17,$30
	AN	$17,&H03
BNK01:	LD	$0,$17
	DIU	$0
	GST	UA,$1
	AN	$1,&HCF
	OR	$1,$0
	PST	UA,$1,DUMP
;
;	exchange address
;
EXADR:	SBC	$28,$31
	RTN	Z
	LDM	$0,$18,4
	LDM	$18,$22,4
	LDM	$22,$0,4
	CAL	SAS01
;
;	32byte dump
;
DUMP:	PRE	IX,$20
	PRE	IZ,EDTOP
	LD	$10,4
DMP01:	LD	$0,$17
	CAL	CNASC
	STI	$1,(IZ+$31)
	GRE	IX,$3
	LD	$0,$4
	CAL	CNASC
	STIW	$0,(IZ+$31)
	LD	$0,$3
	CAL	CNASC
	STIW	$0,(IZ+$31)
	LDW	$6,&H0800
DMP02:	PST	IB,$31
	LDI	$0,(IX+$31)
	PST	IB,&HA0
	AD	$6,$0
	CAL	CNASC
	STIW	$0,(IZ+$30)
	SB	$7,$30
	JR	NZ,DMP02
	LD	$0,$6
	CAL	CNASC
	STIW	$0,(IZ+$30)
	SB	$10,$30
	JR	NZ,DMP01
	PRE	IX,EDTOP
	PRE	IZ,CHRDT
	GST	UA,$0
	LD	$12,$0
	AN	$0,&H3F
	PST	UA,$0
	LD	$8,$31
	CAL	DISPL
	LD	$8,&H10
	CAL	DISPL
	PST	UA,$12
	RTN
;
;	calculate relative jump
;
JR:	SBC	$28,$31
	RTN	Z
	CAL	SASET
	LD	$0,($26)
	LD	$1,$31
	ANC	$0,&H80
	JR	NZ,JR01
	AD	$18,$0
	SBC	$18,&H20
	RTN	C
	LD	$0,$18
	AN	$18,&H07
	OR	$18,&H18
	AN	$0,&HF8
	SB	$0,&H18,INS06
JR01:	AN	$0,&H7F
	SB	$18,$0
	RTN	NC
	LD	$0,$18
	AN	$18,&H07
	INV	$0
	AN	$0,&HF8
	AD	$0,&H08,INS06
;
;	back space
;
BS:	SBC	$28,$31
	RTN	Z
	CAL	LFT01
;
;	delete data
;
DEL:	CAL	DIFF
	RTN	C
DEL01:	PRE	IX,$2
	JR	Z,DEL05
	SBC	$29,$31
	JR	Z,DEL02
	LDW	$0,(IX+$31)
	DID	$1
	AN	$0,&HF0
	OR	$1,$0,DEL03
DEL02:	LD	$1,(IX+$31)
	LD	$0,(IX+$30)
	DIUW	$0
DEL03:	STI	$1,(IX+$31)
	SBW	$4,$30
	JR	NZ,DEL02
DEL04:	LD	$0,(IX+$31)
	DIU	$0,INS05
DEL05:	SBC	$29,$31
	JR	Z,DEL04
	JR	INS02
;
;	insert data
;
INS:	CAL	DIFF
	RTN	C
	PRE	IX,$26
	JR	Z,INS02
INS01:	LD	$0,(IX+$31)
	LDD	$1,(IX-$30)
	DIDW	$1
	ST	$0,(IX+$30)
	SBW	$4,$30
	JR	NZ,INS01
INS02:	LD	$0,(IX+$31)
	SBC	$29,$31
	JR	Z,INS04
INS03:	AN	$0,&HF0,INS05
INS04:	DID	$0
INS05:	ST	$0,(IX+$31)
INS06:	JP	DUMP
;
;	line delete data
;
LDEL:	CAL	DIFF
	LDW	$4,$14
	AN	$0,&H07
	SB	$4,$0,CLM01
;
;	clear data
;
CLM:	CAL	DIFF
	RTN	C
	ADW	$4,$30
CLM01:	SBC	$29,$31
	JR	Z,CLM02
	LD	$0,($2)
	AN	$0,&HF0
	ST	$0,($2)
	ADW	$2,$30
	SBW	$4,$30
CLM02:	CAL	CLRME
	JR	INS06
;
;	fill data
;
FILL:  CAL	DIFF
       RTN	Z
       RTN	C
       PRE	IX,$2
       LD	$0,(IX+$31)
FIL01: STD	$0,(IX+$30)
       SBW	$4,$30
       JR	NZ,FIL01
       JR	INS06
;
;	move cursor to home position
;
HOME:	LD	$18,$31,EXC00
;
;	move cursor to line top
;
LNTOP:	SBC	$28,$31
	JR	NZ,LNT01
	AN	$18,&H0C
	RTN
LNT01:	AN	$18,&H18,EXC00
;
;	move cursor to line end
;
LNEND:	SBC	$28,$31
	JR	NZ,LNE01
	OR	$18,3
	RTN
LNE01:	OR	$18,7
	LD	$29,$30
	RTN
;
;	exchange cursor position
;
EXCSR:	XR	$28,$30
	JR	NZ,EXC01
	AN	$18,&H18
	BID	$18
EXC00:	LD	$29,$31
	RTN
EXC01:	AN	$18,&H0C
	BIU	$18
	RTN
;
;	set sub address
;
SASET:	LDM	$22,$18,4
	SBC	$28,$31
	JR	NZ,SAS01
	AN	$22,&H0C
	BIU	$22
SAS01:	LDW	$26,$24
	ADW	$26,$22
	RTN
;
;	calculate relative jump offset
;
OFFST:	SBC	$28,$31
	RTN	Z
	LDW	$0,$20
	ADW	$0,$18
	PRE	IX,$0
	LD	$4,&H80
	SBW	$0,$26
	JR	NC,OFF01
	CMPW	$0
	LD	$4,$31
OFF01:	LDW	$2,&H0080
	SBCW	$0,$2
	RTN	NC
	OR	$4,$0
	ST	$4,(IX+$31)
;
;	1 byte dump
;
DUMP1:	PRE	IX,EDCSR
	SB	(IX+$31),$29

	PRE	IX,$20
	PST	IB,$31
	LD	$0,(IX+$18)
	PST	IB,&HA0
	CAL	OUTAC

	PRE	IX,EDCSR
	LD	$0,(IX+$31)
	AN	$0,&HE0
	OR	$0,&H1E
	ST	$0,(IX+$31)

	PRE	IX,$20
	LD	$0,$18
	AN	$0,&H18

	LD	$1,7
	PST	IB,$31
	LDI	$0,(IX+$0)
DMP1L:	PST	IB,$31
	LDI	$2,(IX+$31)
	PST	IB,&HA0
	AD	$0,$2
	SB	$1,$30
	JR	NZ,DMP1L

OUTAC:	CAL	CNASC
	PRE	IX,EDCSR
	LD	$6,(IX+$31)
	PRE	IX,EDTOP
	STW	$0,(IX+$6)
	PRE	IZ,CHRDT
	GST	UA,$2
	LD	$12,$2
	AN	$2,&H3F
	PST	UA,$2
	LD	$8,&H82
	LD	$9,$6
	CAL	OUTCH
	LD	$6,$9
	AD	$6,$30
	LD	$0,$1
	CAL	OUTCH
	PST	UA,$12
	RTN
;
;	output character
;
OUTCH:	CAL	LCDXY
	SB	$0,&H20
	LD	$2,$0
	BIU	$2
	AD	$2,$0
	BIU	$2
	LDM	$2,(IZ+$2),6
	STLM	$2,6
	RTN
;
;	DOTDS routine
;
DISPL:	PPO	&HC5
	LD	$0,&H82
	OR	$0,$8
	XRW	$1,$1
	STLM	$0,3
	LD	$7,$31
	PPO     &HC4
DIS01:	LD	$6,$31
DIS02:	LD	$0,$6
	OR	$0,$7
	OR	$0,$8
	LD	$0,(IX+$0)
	SB	$0,&H20
	BIU	$0
	LD	$1,$0
	BIU	$0
	AD	$1,$0
	LDM	$0,(IZ+$1),6
	STLM	$0,6
	AD	$6,$30
	JR	LNZ,DIS02
	AD	$7,&H20
	ANC	$7,&H80
	JR	Z,DIS01
	RTN
;
;	convert binary to ascii
;
CNASC:	LD	$1,$0
	DID	$0
	AD	$0,"0"
	SBC	$0,&H3A
	JR	C,CNA01
	AD	$0,7
CNA01:	AN	$1,&H0F
	AD	$1,"0"
	SBC	$1,&H3A
	RTN	C
	AD	$1,7
	RTN
;
;	distance from cursor to sub
;
DIFF:	LDM	$0,$18,4
	SBC	$28,$31
	JR	NZ,DIF01
	AN	$0,&H0C
	BIU	$0
DIF01:	ADW	$2,$0
	LDW	$4,$26
	SBW	$4,$2
	RTN
;
;	input key
;
@KYIN:	CAL	CSRST
	CAL	CROFF
	LDW	$0,KYSTA
	ST	&H06,($0)
	CAL	KYIN
;
;	cursor set/reset
;
CSRST:	PRE	IX,EDCSR
	LD	$6,(IX+$31)
	LD	$8,&H22
	CAL	LCDXY
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	STL	$30
	RTN
;
;	calulation LCD X-Y address
;
LCDXY:	LD	$2,$6
	AN	$2,&H10
	OR	$2,$8
	LD	$3,$6
	AN	$3,7
	LD	$4,$3
	BIU	$4
	AD	$3,$4
	BIU	$3
	BIU	$3
	LD	$4,$6
	AN	$4,&H08
	DIU	$4
	OR	$3,$4
	LD	$4,$6
	DID	$4
	BID	$4
	PPO	&HC5
	STLM	$2,3
	PPO	&HC4
	RTN
;
;	jump address table
;
JPTBL:	DB	&H1C		; ""
	DW	RIGHT

	DB	&H1D		; ""
	DW	LEFT

	DB	&H1E		; ""  
	DW	UP

	DB	&H1F		; ""
	DW	DOWN

	DB	&H02		; LINE TOP
	DW	LNTOP

	DB	&H06		; LINE END
	DW	LNEND

	DB	&H01		; ROLL UP
	DW	SCLUP

	DB	&H10		; ROLL DOWN
	DW	SCLDN

	DB	&H0B		; HOME
	DW	HOME

	DB	" "
	DW	EXCSR

	DB	&H08		; BS
	DW	BS

	DB	&H11		; DEL
	DW	DEL

	DB	&H12		; INS
	DW	INS

	DB	&H05		; L.DEL
	DW	LDEL

	DB	&H0C		; CLS
	DW	CLM

	DB	&H0D		; EXE
	DW	SASET

	DB	&HF8		; ENG
	DW	ADRRE

	DB	&HF9		; SHIFT+ENG
	DW	CURRE

	DB	&HF2		; ANS
	DW	EXADR
 
	DB	"."
	DW	BANKC

	DB	"O"
	DW	OFFST

	DB	"J"
	DW	JR

	DB	"L"
	DW	FILL
;
;	hexkey data table
;
HEXKY:	DB	"()*/+-"
